#
#  vector.rb
#  Boom
#
#  Created by Mayur Pawashe on 5/17/08.
#  Copyright (c) 2008 zgcoder. All rights reserved.
#

class Vector
	attr_accessor :x, :y, :z
	
	def initialize(x = 0.0, y = 0.0, z = 0.0)
		@x, @y, @z = x, y, z
	end
	
	def Vector.dot_product(vector1, vector2)
		return vector1.x * vector2.x + vector1.y * vector2.y + vector1.z * vector2.z
	end
	
	def Vector.cross_product(vector1, vector2)
		result = Vector.new
		
		result.x = vector1.y * vector2.z - vector1.z * vector2.y
		result.y = vector1.z * vector2.x - vector1.x * vector2.z
		result.z = vector1.x * vector2.y - vector1.y * vector2.x
		
		return result
	end
	
	def Vector.normalize(vector)
		magnitude = Math.sqrt(vector.x * vector.x + vector.y * vector.y + vector.z * vector.z)
		
		normalized_vector = Vector.new
		normalized_vector.x = vector.x / magnitude
		normalized_vector.y = vector.y / magnitude
		normalized_vector.z = vector.z / magnitude
		
		return normalized_vector
	end
end
